<?php

namespace Nest\Model\Events;

use Nest\Model\Entity;
use Nest\Model\Query\EntityQuery;

/**
 * Event fired before entity relations load.
 */
class BeforeLoad extends EntityEvent
{
	/**
	 * @param Entity $entity The entity on which the event is fired.
	 * @param array<string, callable(EntityQuery): void|true> $relations Relations to load.
	 */
	public function __construct(Entity $entity, public readonly array $relations)
	{
		parent::__construct($entity);
	}
}
