<?php

namespace Nest\Model\Exceptions;

use Throwable;

/**
 * Exception thrown when a required field of a model is missing.
 */
class MissingRequiredFieldException extends ModelException
{
	/**
	 * @param string[] $missingFields Names of required fields that are missing.
	 * @param int $code [optional] The Exception code.
	 * @param null|Throwable $previous [optional] The previous throwable used for the exception chaining.
	 */
	public function __construct(public array $missingFields, int $code = 0, ?Throwable $previous = null)
	{
		parent::__construct("The following fields are required: ".implode(", ", $this->missingFields), $code, $previous);
	}
}
