<?php

namespace Nest\Model;

use Nest\Types\Type;

class ReadableFieldBlueprint extends FieldBlueprint
{
	public function getType(): string
	{
		return $this->type;
	}

	/**
	 * Get type instance of the given field.
	 * @return Type Type instance.
	 */
	public function getTypeInstance(): Type
	{
		return new $this->type();
	}

	public function isPrimary(): bool
	{
		return $this->primary;
	}

	public function isIndexed(): bool
	{
		return $this->index;
	}

	public function isUnique(): bool
	{
		return $this->unique;
	}

	public function isRequired(): bool
	{
		return $this->required;
	}

	public function isAutoIncrementing(): bool
	{
		return $this->autoIncrement;
	}

	public function isUnsigned(): bool
	{
		return $this->unsigned;
	}

	public function hasCurrentDateByDefault(): bool
	{
		return $this->currentDateByDefault;
	}

	public function hasCurrentDateOnUpdate(): bool
	{
		return $this->currentDateOnUpdate;
	}
}
